<script lang="ts">
  import { getLocalizer } from '../../../module/utils.js'
  import Formula from './Formula.svelte'

  import { getContext } from 'svelte'
  import { CharacterDataAccessor } from '../../../module/model/character.js'
  import { Writable } from 'svelte/store'
  import { RollableSkill } from '../../../module/character/skill.js'
  import { Character } from '../../../module/character/character.js'

  const localize = getLocalizer()

  let doc = getContext<Writable<CharacterDataAccessor>>('doc')
  let character = new Character($doc)

  $: sources = $doc.sourcesWithFormulas

  const getSourceSkill = (source) => RollableSkill.create(source, character)
</script>

<div class="formulas">
  {#each sources as sourceEntry}
    {#if sourceEntry.formulas.length > 0}
      <h1>
        {sourceEntry.source.name}
        {#if sourceEntry.source}
          {@const sourceSkill = getSourceSkill(sourceEntry.source)}
          (
          {localize(`${sourceSkill.testAttributes[0]}_abbr`)} /
          {localize(`${sourceSkill.testAttributes[1]}_abbr`)} /
          {localize(`${sourceSkill.testAttributes[2]}_abbr`)}
          ) | ZfW: {sourceSkill.value}
        {/if}
      </h1>
      <div>
        {#each sourceEntry.formulas as formula}
          <div class="formula">
            <Formula bind:formula />
          </div>
        {/each}
      </div>
    {/if}
  {/each}
</div>

<style>
  .formula:nth-child(even) {
    background-color: rgba(255, 255, 255, 0.2);
  }
</style>
